C     $Id: gradient21.f,v 1.2 2014/02/28 12:22:13 fclement Exp $

      subroutine gradient21 (n1,ndS,ndT,S,T,gdS,gdT)
c     
      implicit integer (z)
      implicit real*8 (t,f,d)
      include 'common.fh'
      integer ndS,ndT
      dimension S(ndS), T(ndT), gdS(ndS), gdT(ndT)
      real*8 S, T, gdS, gdT
c     
      n = 2*n1
      do   i   =   1   ,   nszz   ,   1
         ssmbz(i) = -gdu(i,n)
      enddo
      do   j   =   1   ,   ny   ,   1
         do   i   =   (j-1)*nx+1   ,   (j-1)*nx+nx-1   ,   1
            ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
         enddo
         i = j*nx
         ssmbz(i) = -smbz(i,1)-smbz(i,2)-smbz(i,3)+ssmbz(i)
      enddo
c     *********************************************************
c     le schema est explicite
c     *********************************************************
      do   i   =   1   ,   j*nx   ,   1
         vvzz(i) = 0
      enddo
      do   j   =   1   ,   ny   ,   1
         do   i   =   (j-1)*nx+1   ,   (j-1)*nx+nx-1   ,   1
            vvzz(i) = ssmbz(i)+vvzz(i)
         enddo
         i = j*nx
         vvzz(i) = ssmbz(i)+vvzz(i)
      enddo
      do   i   =   1   ,   nszz   ,   1
         smbz(i,1) = smbz(i,4)
         smbz(i,2) = smbz(i,5)
         smbz(i,3) = 0
         smbz(i,4) = smbz(i,6)
         smbz(i,5) = 0
         smbz(i,6) = 0
      enddo
      return
      end
